﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using Infragistics.Win.UltraWinToolbars;
using System.Diagnostics;

namespace UltraFormattedTextEditorCustom
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void ultraToolbarsManager1_ToolClick(object sender, Infragistics.Win.UltraWinToolbars.ToolClickEventArgs e)
        {
            switch (e.Tool.Key)
            {
                case "New":
                    ultraFormattedTextEditor1.Text = "";
                    break;
                case "Open":
                    OpenFileDialog fd = new OpenFileDialog();
                    if (fd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                    {
                        FileInfo File = new FileInfo(((System.Windows.Forms.FileDialog)(fd)).FileName);
                        StreamReader FileReader = new StreamReader(File.FullName);
                        ultraFormattedTextEditor1.Text += FileReader.ReadToEnd();
                        FileReader.Close();
                    }
                    break;
                case "Save":
                    SaveFileDialog sfd = new SaveFileDialog();
                    sfd.AddExtension = true;
                    sfd.DefaultExt = ".docx";
                    if (sfd.ShowDialog() == System.Windows.Forms.DialogResult.OK)
                        ultraFormattedTextWordWriter1.Export(ultraFormattedTextEditor1, sfd.FileName);
                    break;
                case "Exit":
                    this.Close();
                    break;
                case "Copy":
                case "Copy1":
                    ultraFormattedTextEditor1.PerformAction(Infragistics.Win.FormattedLinkLabel.FormattedLinkEditorAction.Copy, false, false);
                    break;
                case "Past":
                case "Past1":
                    ultraFormattedTextEditor1.PerformAction(Infragistics.Win.FormattedLinkLabel.FormattedLinkEditorAction.Paste, false, false);
                    break;
                case "Delet":
                case "Delet1":
                    ultraFormattedTextEditor1.PerformAction(Infragistics.Win.FormattedLinkLabel.FormattedLinkEditorAction.Delete, false, false);
                    break;
                case "Cut":
                case "Cut1":
                    ultraFormattedTextEditor1.PerformAction(Infragistics.Win.FormattedLinkLabel.FormattedLinkEditorAction.Cut, false, false);
                    break;
                case "Bold":
                case "Bold1":
                    ultraFormattedTextEditor1.PerformAction(Infragistics.Win.FormattedLinkLabel.FormattedLinkEditorAction.ToggleBold, false, false);
                    break;
                case "Italic":
                case "Italic1":
                    ultraFormattedTextEditor1.PerformAction(Infragistics.Win.FormattedLinkLabel.FormattedLinkEditorAction.ToggleItalics, false, false);
                    break;
                case "Underline":
                case "Underline1":
                    ultraFormattedTextEditor1.PerformAction(Infragistics.Win.FormattedLinkLabel.FormattedLinkEditorAction.ToggleUnderline, false, false);
                    break;
                case "FontColor":
                    Color fontColor = ((PopupColorPickerTool)this.ultraToolbarsManager1.Tools["FontColor"]).SelectedColor;
                    string hexColor = System.Drawing.ColorTranslator.ToHtml(fontColor);
                    this.ultraFormattedTextEditor1.EditInfo.ApplyStyle("Color: " + hexColor, false);
                    this.ultraFormattedTextEditor1.EditInfo.ApplyStyle("Border-color: " + hexColor, false);
                    break;
                case "Left1":
                case "Center1":
                case "Right1":
                    if (this.ultraFormattedTextEditor1.EditInfo.Editor.Value.ToString().Contains((ultraFormattedTextEditor1.EditInfo.Editor).SelectedText + "</p>"))
                    {
                        string tempValue = this.ultraFormattedTextEditor1.EditInfo.Editor.Value.ToString().Replace(((Infragistics.Win.EmbeddableEditorBase)(ultraFormattedTextEditor1.EditInfo.Editor)).SelectedText, "</p>" + "<p align=\"" + e.Tool.Key.ToLower().ToString() + "\" wraptext=\"true\">" + (ultraFormattedTextEditor1.EditInfo.Editor).SelectedText + "</p>");
                        tempValue = tempValue.Replace("p style=\"text-align:", "p align=\"");
                        tempValue = tempValue.Replace("</p></p>", "</p>");
                        this.ultraFormattedTextEditor1.EditInfo.Editor.Value = tempValue;
                    }
                    else
                    {
                        string tempValue = this.ultraFormattedTextEditor1.EditInfo.Editor.Value.ToString().Replace(((Infragistics.Win.EmbeddableEditorBase)(ultraFormattedTextEditor1.EditInfo.Editor)).SelectedText, "<p align=\"" + e.Tool.Key.ToLower().ToString() + "\" wraptext=\"true\">" + (ultraFormattedTextEditor1.EditInfo.Editor).SelectedText + "</p>");
                        this.ultraFormattedTextEditor1.EditInfo.Editor.Value = tempValue;
                    }
                    break;
                case "Left":
                case "Center":
                case "Right":
                case "Justify":
                    if (this.ultraFormattedTextEditor1.EditInfo.Editor.SelectedText == "") return;
                    if (this.ultraFormattedTextEditor1.EditInfo.Editor.Value.ToString().Contains((ultraFormattedTextEditor1.EditInfo.Editor).SelectedText + "</p>"))
                    {

                        string tempValue = this.ultraFormattedTextEditor1.EditInfo.Editor.Value.ToString().Replace(((Infragistics.Win.EmbeddableEditorBase)(ultraFormattedTextEditor1.EditInfo.Editor)).SelectedText, "</p>" + "<p align=\"" + e.Tool.Key.ToLower().ToString() + "\" wraptext=\"true\">" + (ultraFormattedTextEditor1.EditInfo.Editor).SelectedText + "</p>");
                        tempValue = tempValue.Replace("p style=\"text-align:", "p align=\"");
                        tempValue = tempValue.Replace("</p></p>", "</p>");
                        tempValue = tempValue.Replace("<br/>", "");
                        this.ultraFormattedTextEditor1.EditInfo.Editor.Value = tempValue;// +"<br/>";
                    }
                    else
                    {
                        string tempValue = this.ultraFormattedTextEditor1.EditInfo.Editor.Value.ToString();
                        tempValue = tempValue.Replace("<br/>", "");
                        tempValue = this.ultraFormattedTextEditor1.EditInfo.Editor.Value.ToString().Replace(((Infragistics.Win.EmbeddableEditorBase)(ultraFormattedTextEditor1.EditInfo.Editor)).SelectedText, "<p align=\"" + e.Tool.Key.ToLower().ToString() + "\" wraptext=\"true\">" + (ultraFormattedTextEditor1.EditInfo.Editor).SelectedText + "</p>");
                        this.ultraFormattedTextEditor1.EditInfo.Editor.Value = tempValue;// +"<br/>";
                    }
                    break;
                case "FontsHighlight":
                    PopupColorPickerTool highlightTool = (PopupColorPickerTool)e.Tool;
                    Color highlightColor = highlightTool.SelectedColor;// Color.Red;// White;
                    string hexHighlightColor = System.Drawing.ColorTranslator.ToHtml(highlightColor);
                    this.ultraFormattedTextEditor1.EditInfo.ApplyStyle("Background-color: " + hexHighlightColor, false);
                    break;
                case "Hiperlink2":
                    this.ultraFormattedTextEditor1.EditInfo.ShowLinkDialog();
                    break;


            }
        }

        private void ultraToolbarsManager1_ToolValueChanged(object sender, ToolEventArgs e)
        {
            switch (e.Tool.Key)
            {
                case "FontSize":
                    string selectedSize = ((ComboBoxTool)e.Tool).Value.ToString();
                    this.ultraFormattedTextEditor1.EditInfo.ApplyStyle("Font-size: " + selectedSize, false);
                    break;
                case "FontName":
                    string fontName = ((FontListTool)e.Tool).Text;
                    this.ultraFormattedTextEditor1.EditInfo.ApplyStyle("Font-family: " + fontName, false);
                    break;
            }
        }
    }
}
